class Segment {
  PVector a;
  PVector b;
  float len;
  float angle;
  float thickness = 10;
  Segment parent = null;

  Segment (PVector _b, float _len, float _thickness) {
    b = _b;
    len = _len;
    thickness = _thickness;
  }
  
  void calculateA(){
    a = new PVector(cos(angle)*len+b.x, sin(angle)*len+b.y);
  }
  
  void follow(PVector target){
    PVector dir = PVector.sub(a, target);
    angle = dir.heading();
    PVector v = target.get();
    v.sub(b);
    v.div(parent == null ? 5 : 1);
    b.add(v);
    calculateA();
  }
  
  void show(){
    draw();
    pushMatrix();
    translate(b.x < width / 2 ? width : -width, 0);
    draw();
    popMatrix();
    pushMatrix();
    translate(0, b.y < height / 2 ? height : -height);
    draw();
    popMatrix();
  }
  
  void draw() {
    strokeWeight(thickness);
    line(a.x, a.y, b.x, b.y);
  }
}