class Snake {
  Segment[] seg;
  int len;
  int count;
  int thick;
  color col;
  
  Snake (int _len, int _count, int _thick, PVector position, color _col){
    len = _len;
    count = _count;
    thick = _thick;
    col = _col;
    
    seg = new Segment[count];
    seg[0] = new Segment(position, len, thick);
    seg[0].calculateA();
    //seg[0].follow(new PVector (mouseX, mouseY));

    for (int i = 1; i < count; i++){
      seg[i] = new Segment(new PVector (100, 100), len-i, thick-i);
      seg[i].calculateA();
      seg[i].parent = seg[i-1];
      seg[i].follow(seg[i-1].a);
    }
  }
  
  void follow(PVector target){
    PVector inBounds = new PVector(1, 1);
    
    seg[0].follow(target);
    
    inBounds.x = abs(inBounds.x) * seg[0].a.x > width && seg[0].b.x > width ? 1 : (seg[0].a.x < 0 && seg[0].b.x < 0 ? -1 : 0);
    inBounds.y = abs(inBounds.y) * seg[0].a.y > height && seg[0].b.y > height ? 1 : (seg[0].a.y < 0 && seg[0].b.y < 0 ? -1 : 0);
    
    for (int i = 1; i < count; i++){
      seg[i].follow (seg[i].parent.a);
      inBounds.x = abs(inBounds.x) * seg[i].a.x > width && seg[i].b.x > width ? 1 : (seg[i].a.x < 0 && seg[i].b.x < 0 ? -1 : 0);
      inBounds.y = abs(inBounds.y) * seg[i].a.y > height && seg[i].b.y > height ? 1 : (seg[i].a.y < 0 && seg[i].b.y < 0 ? -1 : 0);
    }
    
    if(inBounds.magSq() > 0) {
      for(int i = 0; i < count; i++) {
        seg[i].a.x += inBounds.x * -width;
        seg[i].b.x += inBounds.x * -width;
        seg[i].a.y += inBounds.y * -height;
        seg[i].b.y += inBounds.y * -height;
      }
    }
  }
  
  void show(){
    stroke(col);
    for (int i = 0; i < count-3; i++){
      seg[i].show();
    }
  }
}
